'use strict';

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _chai = require('chai');

var _lodashObjectOmit = require('lodash/object/omit');

var _lodashObjectOmit2 = _interopRequireDefault(_lodashObjectOmit);

var _ = require('../');

var _utils = require('./utils');

var _reactAddonsTestUtils = require('react-addons-test-utils');

describe('branch()', function () {
  it('tests props and applies one of two HoCs, for true and false', function () {
    var SayMyName = (0, _.compose)((0, _.withState)('isBad', 'updateIsBad', false), (0, _.branch)(function (props) {
      return props.isBad;
    }, (0, _.withProps)({ name: 'Heisenberg' }), (0, _.withProps)({ name: 'Walter' })))(_utils.BaseComponent);

    (0, _chai.expect)(SayMyName.displayName).to.equal('withState(branch(BaseComponent))');

    var tree = (0, _reactAddonsTestUtils.renderIntoDocument)(_react2['default'].createElement(SayMyName, { pass: 'through' }));
    var base = (0, _reactAddonsTestUtils.findRenderedComponentWithType)(tree, _utils.BaseComponent);

    (0, _chai.expect)((0, _lodashObjectOmit2['default'])(base.props, 'updateIsBad')).to.eql({
      isBad: false,
      name: 'Walter',
      pass: 'through'
    });

    base.props.updateIsBad(function () {
      return true;
    });
    base = (0, _reactAddonsTestUtils.findRenderedComponentWithType)(tree, _utils.BaseComponent);
    (0, _chai.expect)((0, _lodashObjectOmit2['default'])(base.props, 'updateIsBad')).to.eql({
      isBad: true,
      name: 'Heisenberg',
      pass: 'through'
    });
  });
});