'use strict';

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _chai = require('chai');

var _ = require('../');

var _utils = require('./utils');

var _reactAddonsTestUtils = require('react-addons-test-utils');

describe('defaultProps()', function () {
  var DoReMi = (0, _.defaultProps)({ so: 'do', la: 'fa' })(_utils.BaseComponent);

  it('passes additional props to base component', function () {
    (0, _chai.expect)(DoReMi.displayName).to.equal('defaultProps(BaseComponent)');

    var tree = (0, _reactAddonsTestUtils.renderIntoDocument)(_react2['default'].createElement(DoReMi, null));
    var base = (0, _reactAddonsTestUtils.findRenderedComponentWithType)(tree, _utils.BaseComponent);

    (0, _chai.expect)(base.props).to.eql({ so: 'do', la: 'fa' });
  });

  it('owner props take precendence', function () {
    var tree = (0, _reactAddonsTestUtils.renderIntoDocument)(_react2['default'].createElement(DoReMi, { la: 'ti' }));
    var base = (0, _reactAddonsTestUtils.findRenderedComponentWithType)(tree, _utils.BaseComponent);

    (0, _chai.expect)(base.props).to.eql({ so: 'do', la: 'ti' });
  });
});