'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _chai = require('chai');

var _ = require('../');

var _utils = require('./utils');

var _reactAddonsTestUtils = require('react-addons-test-utils');

describe('doOnReceiveProps()', function () {
  it('fires a callback when receiving new props', function () {
    var spy = sinon.spy();
    var Counter = (0, _.compose)((0, _.withState)('counter', 'updateCounter', 0), (0, _.mapProps)(function (_ref) {
      var updateCounter = _ref.updateCounter;

      var rest = _objectWithoutProperties(_ref, ['updateCounter']);

      return _extends({
        increment: function increment() {
          return updateCounter(function (n) {
            return n + 1;
          });
        }
      }, rest);
    }), (0, _.doOnReceiveProps)(spy))(_utils.BaseComponent);

    var tree = (0, _reactAddonsTestUtils.renderIntoDocument)(_react2['default'].createElement(Counter, { pass: 'through' }));
    var base = (0, _reactAddonsTestUtils.findRenderedComponentWithType)(tree, _utils.BaseComponent);

    (0, _chai.expect)(base.props.pass).to.equal('through');
    (0, _chai.expect)(spy.lastCall.args[0].counter).to.equal(0);
    base.props.increment();
    (0, _chai.expect)(spy.lastCall.args[0].counter).to.equal(1);
    base.props.increment();
    (0, _chai.expect)(spy.lastCall.args[0].counter).to.equal(2);
  });
});