'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _chai = require('chai');

var _ = require('../');

var _utils = require('./utils');

var _reactAddonsTestUtils = require('react-addons-test-utils');

describe('lifecycle()', function () {
  it('gives access to the component instance on setup and teardown', function () {
    var listeners = [];

    var subscribe = function subscribe(listener) {
      listeners.push(listener);
      return function () {
        listeners = listeners.filter(function (l) {
          return l !== listener;
        });
      };
    };

    var emit = function emit() {
      listeners.forEach(function (l) {
        return l();
      });
    };

    var Lifecycle = (0, _.compose)((0, _.lifecycle)(function (component) {
      component.state = { counter: 0 };
      component.dispose = subscribe(function () {
        component.setState(function (state) {
          return { counter: state.counter + 1 };
        });
      });
    }, function (component) {
      component.dispose();
    }))(_utils.BaseComponent);

    // TODO: Use stateless component once React TestUtils supports it

    var Toggle = (function (_Component) {
      _inherits(Toggle, _Component);

      function Toggle() {
        _classCallCheck(this, Toggle);

        _get(Object.getPrototypeOf(Toggle.prototype), 'constructor', this).apply(this, arguments);
      }

      _createClass(Toggle, [{
        key: 'render',
        value: function render() {
          return this.props.isVisible ? _react2['default'].createElement(Lifecycle, null) : null;
        }
      }], [{
        key: 'propTypes',
        value: {
          isVisible: _react.PropTypes.bool
        },
        enumerable: true
      }, {
        key: 'defaultProps',
        value: {
          isVisible: false
        },
        enumerable: true
      }]);

      return Toggle;
    })(_react.Component);

    var ToggleContainer = (0, _.withState)('isVisible', 'updateIsVisible', false)(Toggle);

    var tree = (0, _reactAddonsTestUtils.renderIntoDocument)(_react2['default'].createElement(ToggleContainer, { pass: 'through' }));
    var toggle = (0, _reactAddonsTestUtils.findRenderedComponentWithType)(tree, Toggle);

    toggle.props.updateIsVisible(true);
    (0, _chai.expect)(listeners.length).to.equal(1);
    var base = (0, _reactAddonsTestUtils.findRenderedComponentWithType)(tree, _utils.BaseComponent);

    (0, _chai.expect)(base.props.counter).to.equal(0);
    emit();
    (0, _chai.expect)(base.props.counter).to.equal(1);
    emit();
    (0, _chai.expect)(base.props.counter).to.equal(2);

    toggle.props.updateIsVisible(false);
    (0, _chai.expect)(listeners.length).to.equal(0);
  });
});