'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _chai = require('chai');

var _lodashObjectOmit = require('lodash/object/omit');

var _lodashObjectOmit2 = _interopRequireDefault(_lodashObjectOmit);

var _ = require('../');

var _utils = require('./utils');

var _reactAddonsTestUtils = require('react-addons-test-utils');

describe('mapProps()', function () {
  it('maps owner props to child props', function () {
    var StringConcat = (0, _.compose)((0, _.withState)('strings', 'updateStrings', ['do', 're', 'mi']), (0, _.mapProps)(function (_ref) {
      var strings = _ref.strings;

      var rest = _objectWithoutProperties(_ref, ['strings']);

      return _extends({}, rest, {
        string: strings.join('')
      });
    }))(_utils.BaseComponent);

    (0, _chai.expect)(StringConcat.displayName).to.equal('withState(mapProps(BaseComponent))');

    var tree = (0, _reactAddonsTestUtils.renderIntoDocument)(_react2['default'].createElement(StringConcat, null));
    var base = (0, _reactAddonsTestUtils.findRenderedComponentWithType)(tree, _utils.BaseComponent);

    (0, _chai.expect)((0, _lodashObjectOmit2['default'])(base.props, 'updateStrings')).to.eql({
      string: 'doremi'
    });

    base.props.updateStrings(function (strings) {
      return [].concat(_toConsumableArray(strings), ['fa']);
    });
    (0, _chai.expect)((0, _lodashObjectOmit2['default'])(base.props, 'updateStrings')).to.eql({
      string: 'doremifa'
    });
  });
});