'use strict';

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _chai = require('chai');

var _lodashObjectOmit = require('lodash/object/omit');

var _lodashObjectOmit2 = _interopRequireDefault(_lodashObjectOmit);

var _ = require('../');

var _utils = require('./utils');

var _reactAddonsTestUtils = require('react-addons-test-utils');

describe('onlyUpdateForKeys()', function () {
  it('implements shouldComponentUpdate()', function () {
    var Counter = (0, _.compose)((0, _.withState)('counter', 'updateCounter', 0), (0, _.withState)('foobar', 'updateFoobar', 'foobar'), (0, _.onlyUpdateForKeys)(['counter']), _utils.countRenders)(_utils.BaseComponent);

    (0, _chai.expect)(Counter.displayName).to.equal('withState(withState(onlyUpdateForKeys(countRenders(BaseComponent))))');

    var tree = (0, _reactAddonsTestUtils.renderIntoDocument)(_react2['default'].createElement(Counter, { pass: 'through' }));
    var base = (0, _reactAddonsTestUtils.findRenderedComponentWithType)(tree, _utils.BaseComponent);

    (0, _chai.expect)((0, _lodashObjectOmit2['default'])(base.props, ['updateCounter', 'updateFoobar'])).to.eql({
      counter: 0,
      foobar: 'foobar',
      pass: 'through',
      renderCount: 1
    });

    base.props.updateFoobar(function () {
      return 'barbaz';
    });
    (0, _chai.expect)((0, _lodashObjectOmit2['default'])(base.props, ['updateCounter', 'updateFoobar'])).to.eql({
      counter: 0,
      foobar: 'foobar',
      pass: 'through',
      renderCount: 1
    });

    base.props.updateCounter(function (n) {
      return n + 1;
    });
    (0, _chai.expect)((0, _lodashObjectOmit2['default'])(base.props, ['updateCounter', 'updateFoobar'])).to.eql({
      counter: 1,
      pass: 'through',
      foobar: 'barbaz',
      renderCount: 2
    });
  });
});