'use strict';

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _chai = require('chai');

var _lodashObjectOmit = require('lodash/object/omit');

var _lodashObjectOmit2 = _interopRequireDefault(_lodashObjectOmit);

var _ = require('../');

var _utils = require('./utils');

var _reactAddonsTestUtils = require('react-addons-test-utils');

describe('pure()', function () {
  it('implements shouldComponentUpdate() using shallowEqual()', function () {
    var initialTodos = ['eat', 'drink', 'sleep'];
    var Counter = (0, _.compose)((0, _.withState)('todos', 'updateTodos', initialTodos), _.pure, _utils.countRenders)(_utils.BaseComponent);

    (0, _chai.expect)(Counter.displayName).to.equal('withState(pure(countRenders(BaseComponent)))');

    var tree = (0, _reactAddonsTestUtils.renderIntoDocument)(_react2['default'].createElement(Counter, { pass: 'through' }));
    var base = (0, _reactAddonsTestUtils.findRenderedComponentWithType)(tree, _utils.BaseComponent);

    (0, _chai.expect)((0, _lodashObjectOmit2['default'])(base.props, 'updateTodos')).to.eql({
      todos: initialTodos,
      pass: 'through',
      renderCount: 1
    });

    base.props.updateTodos(initialTodos);
    (0, _chai.expect)((0, _lodashObjectOmit2['default'])(base.props, 'updateTodos')).to.eql({
      todos: initialTodos,
      pass: 'through',
      renderCount: 1
    });

    base.props.updateTodos(function (todos) {
      return todos.slice(0, -1);
    });
    (0, _chai.expect)((0, _lodashObjectOmit2['default'])(base.props, 'updateTodos')).to.eql({
      todos: ['eat', 'drink'],
      pass: 'through',
      renderCount: 2
    });
  });
});