'use strict';

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _chai = require('chai');

var _ = require('../');

var _utils = require('./utils');

var _reactAddonsTestUtils = require('react-addons-test-utils');

describe('renameProp()', function () {
  it('renames a single prop', function () {
    var StringConcat = (0, _.compose)((0, _.withProps)({ so: 123, la: 456 }), (0, _.renameProp)('so', 'do'))(_utils.BaseComponent);

    (0, _chai.expect)(StringConcat.displayName).to.equal('withProps(renameProp(BaseComponent))');

    var tree = (0, _reactAddonsTestUtils.renderIntoDocument)(_react2['default'].createElement(StringConcat, null));
    var base = (0, _reactAddonsTestUtils.findRenderedComponentWithType)(tree, _utils.BaseComponent);

    (0, _chai.expect)(base.props).to.eql({ 'do': 123, la: 456 });
  });
});