'use strict';

var _ = require('../');

var _chai = require('chai');

// Adapted from https://github.com/rackt/react-redux/blob/master/test/utils/shallowEqual.spec.js
describe('shallowEqual()', function () {
  it('returns true if arguments fields are equal', function () {
    (0, _chai.expect)((0, _.shallowEqual)({ a: 1, b: 2, c: undefined }, { a: 1, b: 2, c: undefined })).to.be['true'];

    (0, _chai.expect)((0, _.shallowEqual)({ a: 1, b: 2, c: 3 }, { a: 1, b: 2, c: 3 })).to.be['true'];

    var o = {};
    (0, _chai.expect)((0, _.shallowEqual)({ a: 1, b: 2, c: o }, { a: 1, b: 2, c: o })).to.be['true'];
  });

  it('returns false if first argument has too many keys', function () {
    (0, _chai.expect)((0, _.shallowEqual)({ a: 1, b: 2, c: 3 }, { a: 1, b: 2 })).to.be['false'];
  });

  it('returns false if second argument has too many keys', function () {
    (0, _chai.expect)((0, _.shallowEqual)({ a: 1, b: 2 }, { a: 1, b: 2, c: 3 })).to.be['false'];
  });

  it('returns false if arguments have different keys', function () {
    (0, _chai.expect)((0, _.shallowEqual)({ a: 1, b: 2, c: undefined }, { a: 1, bb: 2, c: undefined })).to.be['false'];
  });
});