'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _chai = require('chai');

var _ = require('../');

var _utils = require('./utils');

var _reactAddonsTestUtils = require('react-addons-test-utils');

describe('withContext() / getContext()', function () {
  it('adds to and grabs from context', function () {
    // Mini React Redux clone
    var store = {
      getState: function getState() {
        return {
          todos: ['eat', 'drink', 'sleep'],
          counter: 12
        };
      }
    };

    var Provider = (function (_Component) {
      _inherits(Provider, _Component);

      function Provider() {
        _classCallCheck(this, Provider);

        _get(Object.getPrototypeOf(Provider.prototype), 'constructor', this).apply(this, arguments);
      }

      _createClass(Provider, [{
        key: 'render',
        value: function render() {
          return this.props.children;
        }
      }]);

      return Provider;
    })(_react.Component);

    Provider = (0, _.compose)((0, _.withContext)({ store: _react.PropTypes.object }, function (props) {
      return { store: props.store };
    }))(Provider);

    (0, _chai.expect)(Provider.displayName).to.equal('withContext(Provider)');

    var connect = function connect(selector) {
      return (0, _.compose)((0, _.getContext)({ store: _react.PropTypes.object }), (0, _.mapProps)(function (props) {
        return selector(props.store.getState());
      }));
    };

    var TodoList = connect(function (_ref) {
      var todos = _ref.todos;
      return { todos: todos };
    })(_utils.BaseComponent);

    (0, _chai.expect)(TodoList.displayName).to.equal('getContext(mapProps(BaseComponent))');

    var tree = (0, _reactAddonsTestUtils.renderIntoDocument)(_react2['default'].createElement(
      Provider,
      { store: store },
      _react2['default'].createElement(TodoList, null)
    ));
    var base = (0, _reactAddonsTestUtils.findRenderedComponentWithType)(tree, _utils.BaseComponent);

    (0, _chai.expect)(base.props.todos).to.eql(['eat', 'drink', 'sleep']);
  });
});